Subject: bug#53805: 27.2; NonGNU ELPA: helm does not install dependencies

From: Pu Xingyu <[email-masked]>
Date: Thu, 10 Feb 2022 22:16:19 +0800

With the newest helm packages in both nongnu and nongnu-devel, 
dependencies seems to be required correctly, but now the installation 
fails with error messages: Lisp nesting exceeds ‘max-lisp-eval-depth’

Here is parted of logs from *Messages* buffer. Emacs version is 
mingw-w64-x86_64-emacs 27.2-4 on Windows.

Contacting host: elpa.nongnu.org:443
Parsing tar file...done
Extracting...done
   INFO     Scraping files for helm-core-autoloads.el...
Generating autoloads for helm-core-pkg.el...done
Generating autoloads for helm-core.el...done
Generating autoloads for helm-lib.el...done
Generating autoloads for helm-multi-match.el...done
Generating autoloads for helm-source.el...done
Generating autoloads for helm.el...done
   INFO     Scraping files for helm-core-autoloads.el...done
Wrote 
c:/Users/stshi/.emacs.d/elpa/helm-core-3.8.4.0.20220210.74849/helm-core-autoloads.el 
[2 times]
package-built-in-p: Lisp nesting exceeds ‘max-lisp-eval-depth’

在 2022/2/7 1:57, Thierry Volpiatto 写道:
> Stefan Monnier <[email-masked]> writes:
>
>>>> The scripts try to handle those problems by cleaning after themselves,
>>>> but apparently not well enough because I've already had to go and
>>>> manually unwedge the system for a few packages that have their own
>>>> `<pkg>-pkg.el` file (`helm` and `helm-core` being among those I've had
>>>> to manually unwedge :-( ).
>>> Not sure to understand this, what do you mean by unwedge? (sorry didn't
>>> find the translation, "décoincer" perhaps?).
>> "décoincer" is what I was thinking, yes.  Concretely, it means I have to
>> log into `elpa.gnu.org` and manually `git reset --hard` at the right
>> spot otherwise the cron job keeps giving me an error on the offending package.
> Ok thanks.
>
>> It's due to a bug in `elpa-admin.el`, but it's one I haven't been able
>> to fix yet (and already "fixed it" once, so there's a chance that if
>> I "fix it" this time it still won't really be fixed).
> Ok.
>
>>> What I could do is creating a new file helm-core.el with only the needed
>>> informations e.g. package-requires and add as well the package-requires
>>> infos in helm.el, this would work for both Melpa and Elpa (after
>>> removing the *pkg.el files).
>>> WDYT?
>> That's the recommended way, yes.
> Ok, so I have applied your patch, thanks.
> I have removed the emacs and async dependencies in helm.el as we already
> do this in helm-core.el (as suggested in your FIXME).
>